!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module ArarePrm
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: arareprm.f90,v 1.2 2005/01/28 12:41:21 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!arare ¹Ԥ뤿ɬפʥѥ᥿ NAMELIST . 
!NAMELIST ̾ϳ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module arareprm

  implicit none

  !--- save °
  save
                                                                 !=begin
  !== Public Interface 
  !
  real(8)  :: Grav   !
  real(8)  :: alpha  !ȸη
  real(8)  :: beta   !󥯥˥륽ˡʤ 0.5, ʤ 1
  real(8)  :: Cm     !ήͥ륮Ǽη 
  real(8)  :: tfil   !åλ֥ե륿η
  real(8)  :: NuH    !Ǵη (ʿ)
  real(8)  :: NuV    !Ǵη (ľ)
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NameList ե뤫 arare ¹Ԥɬפʥѥ᥿
  !
  subroutine arareprm_init(cfgfile)
    !=== Dependency
    use gridset, only: DelX, DelZ
    use timeset, only: DelTimeShort, DelTimeLong
    
    !=== Input 
    character(*), intent(in) :: cfgfile
                                                                 !=end
    !--- ѿ
    real(8)  ::  AlphaH
    real(8)  ::  AlphaV

    !=== NAMELIST
    NAMELIST /arareprm/ Grav, alpha, beta, Cm, tfil, AlphaH, AlphaV

    !--- ѿμФ
    open (10, FILE=cfgfile)
    read(10, NML=arareprm)
    close(10)

    !--- ȸη
    alpha = alpha * ( DelX ** 2.0d0 ) / DelTimeShort

    !--- Ǵη
    NuH  = AlphaH * ( DelX ** 2.0d0 ) / DelTimeLong
    NuV  = AlphaV * ( DelZ ** 2.0d0 ) / DelTimeLong
    
  end subroutine arareprm_init
  
end module arareprm

